c----------------------------------------------------------------------
      function cleb(ia,id,ib,ie,ic,if)
c     clebsh-gordan coefficient
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'clebs.fh'
c
      cleb=0.0
      if(id+ie-if.ne.0) return
      k1=ia+ib+ic
      if((-1.)**k1.lt.0) return
      k1=ia+ib-ic
      k2=ic-iabs(ia-ib)
      k3=min0(k1,k2)
      if(k3.lt.0) return
      if((-1.)**(ib+ie).le.0) return
      if((-1.)**(ic+if).le.0) return
      if(ia.lt.iabs (id)) return
      if(ib.lt.iabs (ie)) return
      if(ic.lt.iabs (if)) return
      if((ia.lt.0).or.(ib.lt.0).or.(ic.lt.0)) return
      if((ia.eq.0).and.(ib.eq.0)) then
        cleb=1.0
        return
      end if
      if(ic.eq.0) then
        fb=ib+1
        cleb=((-1.0 )**((ia-id)/2))/sqrt(fb)
        return
      end if
      fc2=ic+1
      iabcp=(ia+ib+ic)/2+1
      iabc=iabcp-ic
      icab=iabcp-ib
      ibca=iabcp-ia
      iapd=(ia+id)/2+1
      iamd=iapd-id
      ibpe=(ib+ie)/2+1
      ibme=ibpe-ie
      icpf=(ic+if)/2+1
      icmf=icpf-if
      sqfclg=0.5 *(alog(fc2)-faclog(iabcp+1)
     1      +faclog(iabc)+faclog(icab)+faclog(ibca)
     2      +faclog(iapd)+faclog(iamd)+faclog(ibpe)
     3      +faclog(ibme)+faclog(icpf)+faclog(icmf))
      nzmic2=(ib-ic-id)/2
      nzmic3=(ia-ic+ie)/2
      nzmi= max0 (0,nzmic2,nzmic3)+1
      nzmx= min0 (iabc,iamd,ibpe)
      if(nzmx.lt.nzmi) return
      s1=(-1.0 )**(nzmi-1)
      do 400 nz=nzmi,nzmx
        nzm1=nz-1
        nzt1=iabc-nzm1
        nzt2=iamd-nzm1
        nzt3=ibpe-nzm1
        nzt4=nz-nzmic2
        nzt5=nz-nzmic3
        termlg=sqfclg-faclog(nz)-faclog(nzt1)-faclog(nzt2)
     1           -faclog(nzt3)-faclog(nzt4)-faclog(nzt5)
        ssterm=s1*exp(termlg)
        cleb=cleb+ssterm
        s1=-s1
  400 continue
c
      return
      end
