c----------------------------------------------------------------------
      subroutine fnsg2(ich,nrmax,lc1,ur,ui,urp,uip,XX,YY)
c     normalization and t-matrix (in clj) calculation
c     asymptotic (xx,yy) = exp(isigma)*(f + clj*(g + if))
c      asymptotic f = sin(kr - eta*log(2kr) -l*pi/2 + sigma)
c      asymptotic g = cos(---------)
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'base.fh'
      include 'coul.fh'
c
      real*4 XX(*),YY(*)
c
      common /elas1/clj(3),jd
      complex clj
c
      l=lc1+1
      i=ich
c
      if(zz1(ich).lt.0.0001) then
        iz1=0
      else
        iz1=1
        s1=sglcs(l,i)
        s2=sglsn(l,i)
      end if
      f1=fd2(l,i)
      g1=gd2(l,i)
      fp1=fpd2(l,i)
      gp1=gpd2(l,i)
      facu=1.0/urp
      ur=ur*facu
      ui=ui*facu
      uip=uip*facu
c
      t1=fp1*ur-f1
      t2=fp1*ui-f1*uip
      t3=g1-gp1*ur+t2
      t4=-g1*uip+gp1*ui+t1
      t5=1.0/(t3*t3+t4*t4)
      t6=(-t2*t4+t1*t3)*t5
      t7=(t1*t4+t2*t3)*t5
c  t-matrix clj(jd) is not usd nor output in the present version
      t1=f1+t6*g1-t7*f1
      t2=t7*g1+t6*f1
      t3=1.0/(ur*ur+ui*ui)
      t4=(ur*t1+ui*t2)*t3
      t5=(-ui*t1+ur*t2)*t3
      if(iz1.ge.1) then
        fnr=(t4*s1-t5*s2)*facu
        fni=(t4*s2+t5*s1)*facu
      else
        fnr=t4*facu
        fni=t5*facu
      end if
c
      do 30 nr=1,nrmax
        t1=xx(nr)*fnr-yy(nr)*fni
        yy(nr)=yy(nr)*fnr+xx(nr)*fni
        xx(nr)=t1
   30 continue
      return
      end
