      SUBROUTINE OSUCOU(AC,DC,DDC,DMESH,NPTS,NC,ZT,WT,RCOU,ACOU)
C ----------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION AC(NC),DC(NC),DDC(NC)
      COMMON/PARA3/CLP(3,92,238)
      COMMON/RECOIL/RECV,RECS
      COMMON W,C,Z
      real*8 hc/197.326968d0/
      EXTERNAL FCI,FCJ
c
      DATA AMU /931.5016D0/
C------------------------------------------------
      IAA=INT(WT/AMU + 0.0002)
      W=CLP(1,INT(ZT),IAA)
      C=CLP(2,INT(ZT),IAA)
      Z=CLP(3,INT(ZT),IAA)
      IF(C.EQ.0.0D0) THEN
         WRITE(6,888)
C----- USE W=0.0, C=1.05*A**.3 AND Z=0.65 INSTEAD
         W=0.0D0
         C=1.05D0*IAA**0.33333333333333333D0
         Z=0.65D0
         WRITE(6,889)W,C,Z
      END IF
 888  FORMAT(' ',' *** OSUCOU: CHARGE DENSITY IS NOT AVAILABLE ****')
 889  FORMAT(' ',' *** CHARGE DENSITY ASSUMED: W, C, Z = ',3F8.3,/)
C--------------------------------------------------
      ATNO=RECV*ZT
      CP=1.0D0
C -------------------------------------------------------------
      HC2=HC**2
C -------------------------------------------------------------
C     CALCULATION OF COULOMB POTENTIAL AND ITS NORMALIZATION
C     CALCULATED UP TO 20 FM
      SUMI=0.0D0
      SUMJ=0.0D0
      I=2
      XL=0.0D0
      XU=20.0D0
      DX=DMESH
      XB=XL+DX
    2 CALL DGI16(XL,XB,FCI,Y)
      CALL DGI16(XL,XB,FCJ,Y2)
      SUMI=SUMI+Y
      SUMJ=SUMJ+Y2
      AC(I)=SUMI/XB-SUMJ
      DC(I)=-SUMI/XB**2+FCI(XB)/XB-FCJ(XB)
      DDC(I)=(2.0D0*SUMI/XB-FCI(XB))/XB**2
      I=I+1
      IF(XB.GE.XU)GO TO 90
      XL=XB
      XB=XB+DX
      GO TO 2
 90   CONTINUE
      GAM=0.00729729D0*ATNO*HC/SUMI*CP
      DO 20 I=2,NPTS
      AC(I)=(AC(I)+SUMJ)*GAM
      DC(I)=DC(I)*GAM
      DDC(I)=DDC(I)*GAM
   20 CONTINUE
      I=1
      XL=0.0D0
      XB=0.1D-9
      CALL DGI16(XL,XB,FCI,Y0)
      CALL DGI16(XL,XB,FCJ,Y1)
      AC(I)=Y0/XB-Y1
      AC(I)=(AC(I)+SUMJ)*GAM
      DC(I)=(-Y0/XB**2+FCI(XB)/XB-FCJ(XB))*GAM
      DDC(I)=(2.0D0*Y0/XB-FCI(XB))/XB**2*GAM
         GO TO 876
877      CONTINUE
         STOP 
876      CONTINUE
      RETURN
      END
