      SUBROUTINE WCONV(Jconv,nwmax,omegd)
c---------------------------------------------------------------------
C  OUTPUT CONVERGENCE INFORMATION Jconv(nw)
c----------------------------------------------------------------------
c  Input
C    Jconv : Converged Jtr
c    nwmax : maximum number of transferred energies
c    omegd: table of transferred intrinsic energies
c----------------------------------------------------------------------
      dimension omegd(*),Jconv(*)
C
      write(6,1000)
            do nw=1,nwmax
               if(Jconv(nw).eq.0) then
                  write(6,2010) omegd(nw)
               else
                  write(6,2020) omegd(nw),Jconv(nw)
               end if
            end do
C
 1000 format(
     &/'==============================================================='
     &/'CONVERGENCE CHECK INFORMATION'
     &/'---------------------------------------------------------------'
     &/' omega_int   Jconv')
 2010 format(2x, f6.2,'   Not converged !!!')
 2020 format(2x, f6.2,5x,I3)
c
      return
      end
