      subroutine BplusFcal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
c----------------------------------------------------------------------
C Calculate the amplitude (B+F)/2
C----------------------------------------------------------------------
      include 'dimn.fh'
      include 'drive.fh'
      dimension wgt(*)
      complex ampa(nsrdm,2,2,2,2,6)
      complex samp(nsrdm,njdm,njdm2,2,2,2,2)
c
      jtr=itrj-1
      jtr1w=2*jtr
c
      tm=cleb(jtr1w,0,2,0,jtr1w-2,0)
      tp=cleb(jtr1w,0,2,0,jtr1w+2,0)
      t2=tm*tm
      t3=tm*tp
      t4=tp*tp
      tt1=1.0
      tt2=1.0-t2
      tt3=-t3
      tt4=1.0-t4
c
c ampa(r,theta,m,msf,msi,l,delta or epsilon)
c
      if(jtr.ne.0) then
c
c     ampa(r,theta,m,msf,msi,ip=2(u),ils=1(l=j-1),(b+f)/2 )
c
        do 240 msf=1,mxsf
          do 230 msi=1,mxsi
            do 210 n1=1,nsrmax
              do 200 n2=1,nsrmax
                ampa(n1,msf,msi,2,1,5)
     1                =ampa(n1,msf,msi,2,1,5)
     2                +(tt2*(vll(n1,n2,itrj-1,1,2)
     3                      +vll(n1,n2,itrj-1,1,5))/2.0
     3                *samp(n2,itrj,mjr,msf,msi,2,1)
     4                +tt3*(vll(n1,n2,itrj-1,2,2)
     4                    + vll(n1,n2,itrj-1,2,5))/2.0
     5                *samp(n2,itrj,mjr,msf,msi,2,2))*wgt(n2)
  200         continue
  210       continue
  230     continue
  240   continue
c
c     ampa(r,theta,m,msf,msi,ip=1(n),ils=2(l=j,s=1),(b+f)/2)
c
        do 280 msf=1,mxsf
          do 270 msi=1,mxsi
            do 260 n1=1,nsrmax
              do 250 n2=1,nsrmax
                ampa(n1,msf,msi,1,2,5)
     1                =ampa(n1,msf,msi,1,2,5)
     2                +tt1*(vll(n1,n2,itrj,1,5) 
     2                    + vll(n1,n2,itrj,1,5))/2.0
     3                *samp(n2,itrj,mjr,msf,msi,1,2)*wgt(n2)
  250         continue
  260       continue
  270     continue
  280   continue
      end if
c
c     ampa(r,theta,m,msf,msi,ip=2(u),ils=2(l=j+1),(b+f)/2)
c
      do 340 msf=1,mxsf
        do 330 msi=1,mxsi
          do 310 n1=1,nsrmax
            do 300 n2=1,nsrmax
              ampa(n1,msf,msi,2,2,5)
     1              =ampa(n1,msf,msi,2,2,5)
     2              +(tt3*(vll(n2,n1,itrj-1,2,2) 
     2                   + vll(n2,n1,itrj-1,2,5))/2.0
     3              *samp(n2,itrj,mjr,msf,msi,2,1)
     4              +tt4*(vll(n1,n2,itrj+1,1,5)
     4                  + vll(n1,n2,itrj+1,1,5))/2.0
     5              *samp(n2,itrj,mjr,msf,msi,2,2))*wgt(n2)
  300       continue
  310     continue
  330   continue
  340 continue
c
      return
      end
