      subroutine bfcal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
c----------------------------------------------------------------------
c       ampa(r,theta,j,m,msf,msi,ip=2(u),ils,(b-f)term)
c---------------------------------------------------------------------
C  INPUT
c    itrj  
c    mjr   
c    samp  
c    wgt   
c    mxsi  
c    mxsf  
c    nsrmax
c    vll   
C  OUTPUT
c    ampa
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'drive.fh'
      dimension wgt(*)
      complex ampa(nsrdm,2,2,2,2,6)
      complex samp(nsrdm,njdm,njdm2,2,2,2,2)
      complex csamp(nsrdm,2,2,2,2)
c
      jtr=itrj-1
      jtr1w=2*jtr
      mm1=mjr-jtr-1
      mm1w=2*mm1
c
      do 575 ip=1,2
        do 575 ils=1,2
          do 575 msf=1,mxsf
            do 575 msi=1,mxsi
              do 575 n=1,nsrmax
                csamp(n,msf,msi,ip,ils)=(0.0,0.0)
  575 continue
      do 570 ip=1,2
        do 560 ils=1,2
          l=jtr+(ip-1)*(2*ils-3)
          if(l.lt.0) go to 560
          lw=2*l
          do 535 im=1,2
            m=mm1-im*2+3
            if(abs(m).gt.l) go to 535
            mw=2*m
            mu1w=mm1w-mw
            cla=cleb(lw,mw,2,mu1w,jtr1w,mm1w)
            do 520 imm2=1,2
              mm2=m+imm2*2-3
              mm2w=2*mm2
              mu2w=mm2w-mw
              do 530 ij2=1,3
                j2=l+ij2-2
                if(j2.lt.0) go to 530
                if(abs(mm2).gt.j2) go to 530
                j2w=2*j2
                ij21=j2+1
                mj2=mm2+j2+1
                ip2=ij2-(ij2/2)*2+1
                ils2=2-ij2/3
                clb=cleb(lw,mw,2,mu2w,j2w,mm2w)
                do 550 msf=1,mxsf
                  do 540 msi=1,mxsi
                    do 510 n=1,nsrmax
                      csamp(n,msf,msi,ip,ils)=csamp(n,msf,msi,ip,ils)
     1                 +0.5*cla*clb*samp(n,ij21,mj2,msf,msi,ip2,ils2)
  510               continue
  540             continue
  550           continue
  530         continue
  520       continue
  535     continue
  560   continue
  570 continue
      if(jtr.ne.0) then
        do 650 msf=1,mxsf
          do 640 msi=1,mxsi
            do 620 n1=1,nsrmax
              do 610 n2=1,nsrmax
                ampa(n1,msf,msi,2,1,6)
     1                =ampa(n1,msf,msi,2,1,6)
     2                +(vll(n1,n2,itrj-1,1,2)-vll(n1,n2,itrj-1,1,5))
     3                *csamp(n2,msf,msi,2,1)*wgt(n2)
                ampa(n1,msf,msi,1,2,6)
     1                =ampa(n1,msf,msi,1,2,6)
     2                +(vll(n1,n2,itrj,1,2)-vll(n1,n2,itrj,1,5))
     3                *csamp(n2,msf,msi,1,2)*wgt(n2)
  610         continue
  620       continue
  640     continue
  650   continue
      end if
      do 780 msf=1,mxsf
        do 770 msi=1,mxsi
          do 750 n1=1,nsrmax
            do 740 n2=1,nsrmax
              ampa(n1,msf,msi,2,2,6)
     1            =ampa(n1,msf,msi,2,2,6)
     2            +(vll(n1,n2,itrj+1,1,2)-vll(n1,n2,itrj+1,1,5))
     3            *csamp(n2,msf,msi,2,2)*wgt(n2)
  740       continue
  750     continue
  770   continue
  780 continue
c
      return
      end
