      subroutine c1cal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
c----------------------------------------------------------------------
c       ampa(r,theta,j,m,msf,msi,ip=1(n),ils=1(s=0),c1-term)
c----------------------------------------------------------------------
C  INPUT
c    itrj  
c    mjr   
c    samp  
c    wgt   
c    mxsi   
c    mxsf   
c    nsrmax 
c    vll   
C  OUTPUT
c    ampa  
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'drive.fh'
      dimension wgt(*)
      complex ampa(nsrdm,2,2,2,2,6)
      complex samp(nsrdm,njdm,njdm2,2,2,2,2)
      complex d1samp(nsrdm,2,2)
c
      j1=itrj-1
      j1w=2*j1
      mm1=mjr-j1-1
      mm1w=2*mm1
c
      do 500 msf=1,mxsf
        do 500 msi=1,mxsi
          do 500 n=1,nsrmax
            d1samp(n,msf,msi)=(0.0,0.0)
  500 continue
      do 550 ij2=1,3
        j2=j1+ij2-2
        if(j2.lt.0) go to 550
        j2w=2*j2
        ij21=j2+1
        ip2=ij2-(ij2/2)*2+1
        ils2=2-ij2/3
        do 540 imm2=1,2
          mm2=mm1+imm2*2-3
          if(abs(mm2).gt.j2) go to 540
          mj2=mm2+j2+1
          mm2w=2*mm2
          muw=mm2w-mm1w
          cl=cleb(j1w,mm1w,2,muw,j2w,mm2w)
          do 530 msf=1,mxsf
            do 520 msi=1,mxsi
              do 510 n=1,nsrmax
                d1samp(n,msf,msi)=d1samp(n,msf,msi)
     1             +sqrt(0.5)*cl*samp(n,ij21,mj2,msf,msi,ip2,ils2)
  510        continue
  520       continue
  530     continue
  540   continue
  550 continue
      do 640 msf=1,mxsf
        do 630 msi=1,mxsi
          do 620 n1=1,nsrmax
            do 610 n2=1,nsrmax
              ampa(n1,msf,msi,1,1,2)
     1            =ampa(n1,msf,msi,1,1,2)
     2            +vll(n1,n2,itrj,1,3)*d1samp(n2,msf,msi)*wgt(n2)
  610       continue
  620     continue
  630   continue
  640 continue
c
      return
      end
