      SUBROUTINE COUPLE2(itrjd,NW,tzffr,
     &   nsrmax,IRUMAX,NDPMIN,NDPMAX,NDMMAX)
c------------------------------------------------------------------
C     RESPONSE FUNCTION IN R REPRESENTATION: rff((r1,l1),(r2,l2))
c-------------------------------------------------------------------
C INPUT
C   itrjd:
C   NW   :
c   IParit
C   nsrmax
C   IRUMAX
C   NDPMIN:
C   NDPMAX
C   kltrmx:maximum number of the index for the transferred l
C   kstrmn:
C   kstrmx:
C   istr(ist2)
C   tzffr(IRU,i1,i2,ist1,ist2,NDP1,NDP2)
C OUTPUT
C   rffr(n1,n2,ip,kls,itrj1,NW,NDM)
c-------------------------------------------------------------------
      include 'dimn.fh'
      include 'fund2.fh'
      include 'form.fh'
C
      complex tzffr(2,nrdm,nrdm,2,2,ndmdp,ndmdp)
C
      IP = IParit
      itrj1=itrjd+1
      jtr=itrj1-1
C
      do 235 NDM=1,4
      do 235 kls=1,4
        do 235 n1=1,nsrmax
          do 235 n2=1,nsrmax
            rffr(n1,n2,ip,kls,itrj1,NW,NDM)=0.0
  235 continue
c
      IRU = IRUMAX
      do 231 NDP1=NDPMIN,NDPMAX
      do 232 NDP2=NDP1,NDPMAX
        if((NDP1.eq.1).and.(NDP2.eq.1)) NDM=1
        if((NDP1.eq.1).and.(NDP2.eq.2)) NDM=2
        if((NDP1.eq.2).and.(NDP2.eq.2)) NDM=3
      do 250 kltr1=1,kltrmx
        l1=ltr(kltr1)
        do 240 kltr2=1,kltrmx
          l2=ltr(kltr2)
          do 230 ist1=kstrmn,kstrmx
            s1=istr(ist1)
            do 220 ist2=kstrmn,kstrmx
              s2=istr(ist2)
              kls=(2-ip)*(s1*2+s2+1)+(ip-1)*(l1-jtr+1+(l2-jtr+1)/2+1)
              do 210 n2=1,nsrmax
                i2=n2+nsrmax*(kltr2-1)
                do 200 n1=1,nsrmax
                  i1=n1+nsrmax*(kltr1-1)
                  rffr(n1,n2,ip,kls,itrj1,NW,NDM)=
     1                   aimag(tzffr(IRU,i1,i2,ist1,ist2,NDP1,NDP2))
  200           continue
  210         continue
  220       continue
  230     continue
  240   continue
  250 continue
  232 continue
  231 continue
C
      do 300 kls = 1,4
      do 300 n2=1,nsrmax
      do 300 n1=1,nsrmax
         if(NDMMAX.eq.3) then
            rffr(n1,n2,ip,kls,itrj1,NW,4)=
     1                    rffr(n1,n2,ip,kls,itrj1,NW,1)
     1                   +rffr(n1,n2,ip,kls,itrj1,NW,2)
     1                   +rffr(n1,n2,ip,kls,itrj1,NW,3)
         else
            rffr(n1,n2,ip,kls,itrj1,NW,4)=rffr(n1,n2,ip,kls,itrj1,NW,1)
         endif
  300 continue
C
      return
      end
