c----------------------------------------------------------------------
      subroutine sigma(lmax,eta,sigma0,sigmad)
c     coulomb phase shift
c----------------------------------------------------------------------
      dimension sigmad(*)
c
      if(eta.lt.10.) then
        eta2=eta*eta
        t1=eta2+16.0
        t2=t1*t1
        t4=t2*t2
        t6=eta/6.0
c
        sigma0=-(eta/(12.0*t1))*(1.0+(eta2-48.0)/(30.0*t2)+(eta2**2
     1  -160.0*eta2+1280.0)/(t4*105.0))-eta+3.0*t6*alog(t1)+3.5
     2  *atan(1.5*t6)-atan (eta)-atan (3.0*t6)-atan (2.0*t6)
      else
        t1=1.0/eta
        t2=t1*t1
        t3=t1*t2
        t5=t3*t2
        t7=t5*t2
        t9=t7*t2
        sigma0=0.7853981634d0+eta*alog(eta)-eta
     1      -(0.08333333333d0*t1+0.00277777777d0*t3
     2       +0.00079365079d0*t5+0.00059523810d0*t7
     3       +0.00084175084d0*t9)
      end if
      mn=sigma0/6.2831853072d0
      sigma0=sigma0-6.2831853072d0*mn
c
      sigmad(1)=sigma0
      do 30 l=2,lmax
        fl1=l-1
        sigmad(l)=sigmad(l-1)+atan (eta/fl1)
   30 continue
      return
      end
